Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/ZOOMakefile.opts.in
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 741)
@@ -55,4 +55,11 @@
 RUBY_FILE=@RUBY_FILE@
 
+JSON_LDFLAGS=@JSON_LDFLAGS@
+JSON_CPPFLAGS=@JSON_CPPFLAGS@
+
+RABBITMQ_LDFLAGS=@RABBITMQ_LDFLAGS@
+RABBITMQ_CPPFLAGS=@RABBITMQ_CPPFLAGS@
+RABBITMQ_FILE=@RABBITMQ_FILE@
+
 JS_ENABLED=@JS_ENABLED@
 JSCFLAGS=@JS_CPPFLAGS@
@@ -96,5 +103,5 @@
 SAGA_FILE=@SAGA_FILE@
 
-CFLAGS=@RELY_ON_DB@ @DEB_DEF@ -fpic ${GLIB_CPPFLAGS} ${YAML_CFLAGS} ${MACOS_CFLAGS} ${MS_CFLAGS} -I../../thirds/cgic206 -I. -DLINUX_FREE_ISSUE #-DDEBUG #-DDEBUG_SERVICE_CONF
-LDFLAGS=-lzoo_service @DEFAULT_LIBS@ -L../../thirds/cgic206 -lcgic ${GDAL_LIBS} ${XML2LDFLAGS} ${GLIB_LDFLAGS} ${PYTHONLDFLAGS} ${PERLLDFLAGS}  ${PHPLDFLAGS} ${JAVALDFLAGS} ${JSLDFLAGS} -lfcgi -lcrypto -luuid ${MS_LDFLAGS} ${MACOS_LD_FLAGS} ${MACOS_LD_NET_FLAGS} ${YAML_LDFLAGS} ${OTBLDFLAGS} ${SAGA_LDFLAGS}
+CFLAGS= @RELY_ON_DB@ @DEB_DEF@ -fpic ${GLIB_CPPFLAGS} ${YAML_CFLAGS} ${GDAL_CFLAGS} ${MACOS_CFLAGS} ${MS_CFLAGS} ${RABBITMQ_CPPFLAGS} -I../../thirds/cgic206 -I. -DLINUX_FREE_ISSUE #-DDEBUG #-DDEBUG_SERVICE_CONF
+LDFLAGS=-lzoo_service @DEFAULT_LIBS@ -L../../thirds/cgic206 -lcgic ${GDAL_LIBS} ${XML2LDFLAGS} ${GLIB_LDFLAGS} ${PYTHONLDFLAGS} ${PERLLDFLAGS} ${JSON_LDFLAGS} ${RABBITMQ_LDFLAGS} ${PHPLDFLAGS} ${JAVALDFLAGS} ${JSLDFLAGS} -lfcgi -lcrypto -luuid ${MS_LDFLAGS} ${MACOS_LD_FLAGS} ${MACOS_LD_NET_FLAGS} ${YAML_LDFLAGS} ${OTBLDFLAGS} ${SAGA_LDFLAGS}
 
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/caching.c
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/caching.c	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/caching.c	(revision 741)
@@ -215,5 +215,5 @@
 	    fcontent=(char*)malloc((hInternet->ihandle[index].nDataLen+1)*sizeof(char));
 	    if(fcontent == NULL){
-	      return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
+	      return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL,NULL);
 	    }
 	    size_t dwRead;
@@ -233,5 +233,5 @@
 	    tmpMap->value=(char*)malloc((fsize+1)*sizeof(char));
 	    if(tmpMap->value==NULL){
-	      return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
+	      return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL,NULL);
 	    }
 	    memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
@@ -277,5 +277,5 @@
 void addRequestToQueue(maps** m,HINTERNET* hInternet,const char* url,bool req){
   hInternet->waitingRequests[hInternet->nb]=strdup(url);
-  hInternet->ihandle[hInternet->nb].header=NULL;
+  //hInternet->ihandle[hInternet->nb].header=NULL;
   if(req)
     InternetOpenUrl(hInternet,hInternet->waitingRequests[hInternet->nb],NULL,0,INTERNET_FLAG_NO_CACHE_WRITE,0);
@@ -304,5 +304,5 @@
  */
 int loadRemoteFile(maps** m,map** content,HINTERNET* hInternet,char *url){
-  char* fcontent;
+  char* fcontent = NULL;
   char* cached=isInCache(*m,url);
   char *mimeType=NULL;
@@ -338,10 +338,10 @@
     }
 
-  }else{    
+  }else{
     addRequestToQueue(m,hInternet,url,true);
     return 0;
   }
   if(fsize==0){
-    return errorException(*m, _("Unable to download the file."), "InternalError",NULL);
+    return errorException(*m, _("Unable to download the file."), "InternalError",NULL,NULL);
   }
   if(mimeType!=NULL){
@@ -354,7 +354,15 @@
 
   tmpMap->value=(char*)malloc((fsize+1)*sizeof(char));
-  if(tmpMap->value==NULL)
-    return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
+ 
+ if(tmpMap->value==NULL || fcontent == NULL)
+    return errorException(*m, _("Unable to allocate memory"), "InternalError",NULL,NULL);
   memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
+
+ 
+ 
+ 
+  //if(tmpMap->value==NULL)
+    //return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL,NULL);
+  //memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
 
   char ltmp1[256];
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/configure.ac
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/configure.ac	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/configure.ac	(revision 741)
@@ -58,4 +58,25 @@
 AC_SUBST([RELY_ON_DB])
 
+
+AC_ARG_WITH([rabbitmq],
+    [AS_HELP_STRING([--with-rabbittmq], [asynchronous requests management with rabbitmq  ])],
+    [AMQP="-DAMQP"], [AMQP=""])
+
+if test -z "$AMQP"
+then
+    RABBITMQ_LDFLAGS=""
+    RABBITMQ_CPPFLAGS=""
+    RABBITMQ_FILE=""
+else
+    AC_CHECK_LIB([rabbitmq], [main])
+    RABBITMQ_LDFLAGS=`pkg-config --libs librabbitmq`
+    RABBITMQ_CPPFLAGS="-DAMQP" `pkg-config --cflags librabbitmq`
+    RABBITMQ_FILE="zoo_amqp.o"
+    RELY_ON_DB="-DRELY_ON_DB"
+    AC_SUBST([RELY_ON_DB])
+fi
+AC_SUBST([RABBITMQ_LDFLAGS])
+AC_SUBST([RABBITMQ_CPPFLAGS])
+AC_SUBST([RABBITMQ_FILE])
 
 # ===========================================================================
@@ -418,6 +439,7 @@
 	LIBS_SAVE="$LIBS"
 	LIBS="$PYTHON_LDFLAGS"
-	PY_LIB=`$PYTHONCONFIG --libs | sed -e 's/^.*\(python2\..\)$/\1/'`
-	AC_CHECK_LIB([$PY_LIB], [PyObject_CallObject], [], [AC_MSG_ERROR([could not find libpython])], [])
+	#PY_LIB=`$PYTHONCONFIG --libs | sed -e 's/^.*\(python2\..\)$/\1/'`
+	#PY_LIB=`$PYTHONCONFIG --libs`
+	#AC_CHECK_LIB([$PY_LIB], [PyObject_CallObject], [], [AC_MSG_ERROR([could not find libpython])], [])
 	AC_SUBST([PYTHON_CPPFLAGS])
 	AC_SUBST([PYTHON_LDFLAGS])
@@ -598,4 +620,17 @@
 AC_SUBST([JAVA_FILE])
 
+
+# ===========================================================================
+# Detect if json-c is available
+# ===========================================================================
+
+AC_CHECK_LIB([json-c], [main])
+JSON_LDFLAGS=`pkg-config --libs json-c`
+JSON_CPPFLAGS=`pkg-config --cflags json-c`
+
+AC_SUBST([JSON_LDFLAGS])
+AC_SUBST([JSON_CPPFLAGS])
+
+
 # ===========================================================================
 # Detect if ruby is installed
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/request_parser.c
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/request_parser.c	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/request_parser.c	(revision 741)
@@ -92,5 +92,5 @@
 		       _("The maximum allowed occurrences for <%s> (%i) was exceeded."),
 		       mi->name, atoi (testMap->value));
-	      errorException (m, emsg, "InternalError", NULL);
+	      errorException (m, emsg, "InternalError", NULL,NULL);
 	      return -1;
 	    }
@@ -113,5 +113,5 @@
 			   ("ZOO-Kernel was unable to load your data for %s position %s."),
 			   mi->name, tmpMap->value);
-		  errorException (m, emsg, "InternalError", NULL);
+		  errorException (m, emsg, "InternalError", NULL,NULL);
 		  return -1;
 		}
@@ -124,5 +124,5 @@
 		       ("The maximum allowed occurrences for <%s> is one."),
 		       mi->name);
-	      errorException (m, emsg, "InternalError", NULL);
+	      errorException (m, emsg, "InternalError", NULL,NULL);
 	      return -1;
 	    }
@@ -213,5 +213,5 @@
 	free(cursor_input);
 	return errorException (*main_conf, _("Unable to allocate memory."),
-			       "InternalError", NULL);
+			       "InternalError", NULL,NULL);
       }
     int i = 0;
@@ -224,5 +224,5 @@
 	    free(cursor_input);
 	    return errorException (*main_conf, _("Unable to allocate memory."),
-				   "InternalError", NULL);
+				   "InternalError", NULL,NULL);
 	  }
 	snprintf (inputs_as_text[i], strlen (pToken) + 1, "%s", pToken);
@@ -261,5 +261,5 @@
 		    return errorException (*main_conf,
 					   _("Unable to allocate memory."),
-					   "InternalError", NULL);
+					   "InternalError", NULL,NULL);
 		  }
 		tmpmaps->name = zStrdup (tmpn);
@@ -316,15 +316,14 @@
 				 tmpv1 + 1);
 			free(cursor_input);
-			return errorException (*main_conf, emsg, "InternalError", NULL);
+			return errorException (*main_conf, emsg, "InternalError", NULL,NULL);
 		      }
 		    addToMap (tmpmaps->content, tmpn1, tmpx2);
-		    {
 		      if (loadRemoteFile
 			  (&*main_conf, &tmpmaps->content, hInternet, tmpx2) < 0)
 			{
 			  free(cursor_input);
-			  return errorException (*main_conf, "Unable to fetch any ressource", "InternalError", NULL);
+			  return errorException (*main_conf, "Unable to fetch any ressource", "InternalError", NULL,NULL);
 			}
-		      }
+		      
 		    free (tmpx2);
 		    addIntToMap (tmpmaps->content, "Order", hInternet->nb);
@@ -350,5 +349,5 @@
 			  {
 			    free(cursor_input);
-			    return errorException (*main_conf, "Unable to append maps", "InternalError", NULL);
+			    return errorException (*main_conf, "Unable to append maps", "InternalError", NULL,NULL);
 			  }
 		      }
@@ -402,5 +401,5 @@
 	  free(cursor_output);
 	  return errorException (*main_conf, _("Unable to allocate memory"),
-				 "InternalError", NULL);
+				 "InternalError", NULL,NULL);
 	}
       int i = 0;
@@ -413,5 +412,5 @@
 	      free(cursor_output);
 	      return errorException (*main_conf, _("Unable to allocate memory"),
-				     "InternalError", NULL);
+				     "InternalError", NULL,NULL);
 	    }
 	  snprintf (outputs_as_text[i], strlen (pToken) + 1, "%s",
@@ -440,5 +439,5 @@
 						 _
 						 ("Unable to allocate memory."),
-						 "InternalError", NULL);
+						 "InternalError", NULL,NULL);
 			}
 		      tmp_output->name = zStrdup (tmpc);
@@ -536,5 +535,5 @@
 						 _
 						 ("Unable to allocate memory."),
-						 "InternalError", NULL);
+						 "InternalError", NULL,NULL);
 			}
 		      tmpmaps->name = zStrdup ((char *) val);
@@ -561,5 +560,5 @@
 						 _
 						 ("Unable to allocate memory."),
-						 "InternalError", NULL);
+						 "InternalError", NULL,NULL);
 			}
 		      tmpmaps->name = zStrdup ("missingIndetifier");
@@ -613,5 +612,5 @@
 							     _("Unable to add a request in the queue."),
 							     "InternalError",
-							     NULL);
+							     NULL,NULL);
 				    }
 				  addIntToMap (tmpmaps->content, "Order", hInternet->nb);
@@ -665,5 +664,5 @@
 							     ("Unable to allocate memory."),
 							     "InternalError",
-							     NULL);
+							     NULL,NULL);
 				    }
 				  snprintf (has,
@@ -675,11 +674,12 @@
 			      xmlFree (val);
 			    }
-			  hInternet->ihandle[hInternet->nb].header = NULL;
-			  hInternet->ihandle[hInternet->nb].header =
-			    curl_slist_append (hInternet->ihandle
-					       [hInternet->nb].header,
-					       has);
-			  if (has != NULL)
-			    free (has);
+                if (has != NULL){
+                            hInternet->ihandle[hInternet->nb].header = NULL;
+                            hInternet->ihandle[hInternet->nb].header =
+                              curl_slist_append (hInternet->ihandle
+                                                 [hInternet->nb].header,
+                                                 has);
+                            free (has);
+                }
 			}
 		      else
@@ -781,5 +781,5 @@
 							   ("Unable to allocate memory."),
 							   "InternalError",
-							   NULL);
+							   NULL,NULL);
 				  }
 				size_t bRead;
@@ -951,5 +951,5 @@
 				  xmlDocDumpFormatMemoryEnc (doc1, &mv,
 							     &buffersize,
-							     "utf-8", 1);
+							     "utf-8", 0);
 				  char size[1024];
 				  sprintf (size, "%d", buffersize);
@@ -966,10 +966,7 @@
 				    xmlDocDumpFormatMemoryEnc (doc1, &mv,
 							       &buffersize,
-							       "utf-8", 1);
-				    char size[1024];
-				    sprintf (size, "%d", buffersize);
-				    addToMap (tmpmaps->content, "size",
-					      size);
-				    xmlFreeDoc (doc2);
+							       "utf-8", 0);
+				    addIntToMap(tmpmaps->content, "size",buffersize);
+                    xmlFreeDoc (doc2);
 				    xmlFreeDoc (doc1);
 				  }
@@ -1024,5 +1021,5 @@
 					       _("Unable to append maps to maps."),
 					       "InternalError",
-					       NULL);
+					       NULL,NULL);
 		      }
 		  }
@@ -1113,5 +1110,5 @@
 	    {
 	      return errorException (*main_conf, _("Unable to allocate memory."),
-				     "InternalError", NULL);
+				     "InternalError", NULL,NULL);
 	    }
 	  tmpmaps->name = zStrdup ("unknownIdentifier");
@@ -1205,5 +1202,5 @@
 				     _
 				     ("Unable to allocate memory."),
-				     "InternalError", NULL);
+				     "InternalError", NULL,NULL);
 	    }
 	    tmpmaps->name = zStrdup ("unknownIdentifier");
@@ -1292,5 +1289,5 @@
 				     _
 				     ("Duplicate <Output> elements in WPS Execute request"),
-				     "InternalError", NULL);
+				     "InternalError", NULL,NULL);
 	    }
 	    else {
@@ -1320,5 +1317,5 @@
  * @return 0 on success, -1 on failure
  */
-int xmlParseRequest(maps** main_conf,const char* post,map** request_inputs,service* s,maps** inputs,maps** outputs,HINTERNET* hInternet){
+int xmlParseRequest(maps** main_conf,const char* post,map** request_inputs,service* s,maps** inputs,maps** outputs,HINTERNET* hInternet,struct cgi_env *cgi){
 
   map* version=getMapFromMaps(*main_conf,"main","rversion");
@@ -1326,5 +1323,5 @@
 
   xmlInitParser ();
-  xmlDocPtr doc = xmlParseMemory (post, cgiContentLength);
+  xmlDocPtr doc = xmlParseMemory (post, cgi->cgiContentLength);
 
   /**
@@ -1428,5 +1425,5 @@
  * @see kvpParseOutputs,kvpParseInputs,xmlParseRequest
  */
-int parseRequest(maps** main_conf,map** request_inputs,service* s,maps** inputs,maps** outputs,HINTERNET* hInternet){
+int parseRequest(maps** main_conf,map** request_inputs,service* s,maps** inputs,maps** outputs,HINTERNET* hInternet,struct cgi_env *cgi){
   map *postRequest = NULL;
   postRequest = getMap (*request_inputs, "xrequest");
@@ -1443,5 +1440,5 @@
     {
       //Parse XML request
-      if(xmlParseRequest(main_conf,postRequest->value,request_inputs,s,inputs,outputs,hInternet)<0){
+      if(xmlParseRequest(main_conf,postRequest->value,request_inputs,s,inputs,outputs,hInternet,cgi)<0){
 	return -1;
       }
@@ -1465,9 +1462,13 @@
  * @see runHttpRequests
  */
-int validateRequest(maps** main_conf,service* s,map* original_request, maps** request_inputs,maps** request_outputs,HINTERNET* hInternet){
-
+int validateRequest(maps** main_conf,service* s,map* original_request, maps** request_inputs,maps** request_outputs,HINTERNET* hInternet,struct cgi_env * cgi){
+  fprintf(stderr,"STEP 1 VALIDATE \n");
+  
   runHttpRequests (main_conf, request_inputs, hInternet);
+fprintf(stderr,"STEP 2 VALIDATE \n");
+  
   InternetCloseHandle (hInternet);
-
+  fprintf(stderr,"STEP 3 VALIDATE \n");
+                
   map* errI=NULL;
   char *dfv = addDefaultValues (request_inputs, s->inputs, *main_conf, 0,&errI);
@@ -1491,5 +1492,5 @@
               addToMap (tmpe, "locator", ptr->name);
               addToMap (tmpe, "text", tmps);
-              printExceptionReportResponse (*main_conf, tmpe);
+              printExceptionReportResponse (*main_conf, tmpe,NULL);
               freeMap (&tmpe);
               free (tmpe);
@@ -1499,8 +1500,11 @@
       ptr = ptr->next;
     }
-
+fprintf(stderr,"STEP 4 VALIDATE \n");
+  dumpMaps(*request_outputs);
   map* errO=NULL;
   char *dfv1 =
     addDefaultValues (request_outputs, s->outputs, *main_conf, 1,&errO);
+    fprintf(stderr,"STEP 4 - 1 VALIDATE \n");
+  
   if (strcmp (dfv1, "") != 0 || strcmp (dfv, "") != 0)
     {
@@ -1526,4 +1530,6 @@
 	  }
 	}
+    fprintf(stderr,"STEP 4 - 2 VALIDATE \n");
+  
       if (strcmp (dfv1, "") != 0)
         {
@@ -1553,5 +1559,7 @@
 	  }
 	}
-      printExceptionReportResponse (*main_conf, tmpe);
+    fprintf(stderr,"STEP 4 - 3 VALIDATE \n");
+  
+      printExceptionReportResponse (*main_conf, tmpe,NULL);
       if(errI!=NULL){
 	freeMap(&errI);
@@ -1567,4 +1575,6 @@
     }
   maps *tmpReqI = *request_inputs;
+  fprintf(stderr,"STEP 5 VALIDATE \n");
+  
   while (tmpReqI != NULL)
     {
@@ -1572,5 +1582,5 @@
       if (getMap (tmpReqI->content, "isFile") != NULL)
         {
-          if (cgiFormFileName (tmpReqI->name, name, sizeof (name)) ==
+          if (cgiFormFileName (tmpReqI->name, name, sizeof (name),&cgi) ==
               cgiFormSuccess)
             {
@@ -1586,8 +1596,8 @@
               int got, t;
               map *path = getMapFromMaps (*main_conf, "main", "tmpPath");
-              cgiFormFileSize (tmpReqI->name, &size);
+              cgiFormFileSize (tmpReqI->name, &size,&cgi);
               cgiFormFileContentType (tmpReqI->name, contentType,
-                                      sizeof (contentType));
-              if (cgiFormFileOpen (tmpReqI->name, &file) == cgiFormSuccess)
+                                      sizeof (contentType),&cgi);
+              if (cgiFormFileOpen (tmpReqI->name, &file,&cgi) == cgiFormSuccess)
                 {
                   t = -1;
@@ -1643,5 +1653,6 @@
       tmpReqI = tmpReqI->next;
     }
-
+fprintf(stderr,"STEP FINAL VALIDATE \n");
+  
   ensureDecodedBase64 (request_inputs);
   return 1;
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/request_parser.h
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/request_parser.h	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/request_parser.h	(revision 741)
@@ -44,8 +44,8 @@
   int xmlParseInputs(maps**,service*,maps**,xmlDocPtr,xmlNodeSet*,HINTERNET*);
   int xmlParseOutputs(maps**,map**,maps**,xmlDocPtr,xmlNodePtr,bool);
-  int xmlParseRequest(maps**,const char*,map**,service*,maps**,maps**,HINTERNET*);
-  int parseRequest(maps**,map**,service*,maps**,maps**,HINTERNET*);
+  int xmlParseRequest(maps**,const char*,map**,service*,maps**,maps**,HINTERNET*,struct cgi_env *);
+  int parseRequest(maps**,map**,service*,maps**,maps**,HINTERNET*,struct cgi_env *);
   void checkValidValue(map*,map**,const char*,const char**,int);
-  int validateRequest(maps**,service*,map*,maps**,maps**,HINTERNET*);
+  int validateRequest(maps**,service*,map*,maps**,maps**,HINTERNET*,struct cgi_env *);
 
 #ifdef __cplusplus
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/response_print.h
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/response_print.h	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/response_print.h	(revision 741)
@@ -25,4 +25,6 @@
 #ifndef ZOO_RESPONSE_PRINT_H
 #define ZOO_RESPONSE_PRINT_H 1
+
+#include <fcgiapp.h>
 
 #pragma once 
@@ -69,5 +71,5 @@
 #include <direct.h>
 #endif
-#include <stdio.h>
+
 #include <time.h>
 #include <ctype.h>
@@ -201,7 +203,7 @@
   void zooXmlCleanupDocs();
   
-  void printExceptionReportResponse(maps*,map*);
+  void printExceptionReportResponse(maps*,map*,FCGX_Stream *);
   xmlNodePtr createExceptionReportNode(maps*,map*,int);
-  void printProcessResponse(maps*,map*,int,service*,const char*,int,maps*,maps*);
+  void printProcessResponse(maps*,map*,int,service*,const char*,int,maps*,maps*,FCGX_Stream *);
   xmlNodePtr printWPSHeader(xmlDocPtr,maps*,const char*,const char*,const char*,int);
   xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr,maps*,const char*);
@@ -209,16 +211,16 @@
   void printDescribeProcessForProcess(maps*,xmlNodePtr,service*);
   void printFullDescription(int,elements*,const char*,xmlNsPtr,xmlNsPtr,xmlNodePtr,int);
-  void printDocument(maps*,xmlDocPtr,int);
+  void printDocument(maps*,xmlDocPtr,int,FCGX_Stream *);
   void printDescription(xmlNodePtr,xmlNsPtr,const char*,map*,int);
   void printIOType(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,xmlNsPtr,elements*,maps*,const char*,int);
   map* parseBoundingBox(const char*);
   void printBoundingBox(xmlNsPtr,xmlNodePtr,map*);
-  void printBoundingBoxDocument(maps*,maps*,FILE*);
+  void printBoundingBoxDocument(maps*,maps*,FILE*,FCGX_Stream *);
   void printOutputDefinitions(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,maps*,const char*);
-  void printStatusInfo(maps*,map*,char*);
-
-  void outputResponse(service*,maps*,maps*,map*,int,maps*,int);
-
-  int errorException(maps *, const char *, const char *, const char*);
+  void printStatusInfo(maps*,map*,char*,FCGX_Stream *);
+
+  void outputResponse(service*,maps*,maps*,map*,int,maps*,int,FCGX_Stream *);
+
+  int errorException(maps *, const char *, const char *, const char*,FCGX_Stream *);
 
   xmlNodePtr soapEnvelope(maps*,xmlNodePtr);
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/server_internal.c
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/server_internal.c	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/server_internal.c	(revision 741)
@@ -850,10 +850,10 @@
  * @param req the request (GetStatus / GetResult)
  */
-void runGetStatus(maps* conf,char* pid,char* req){
+void runGetStatus(maps* conf,char* pid,char* req,FCGX_Stream* out){
   map* r_inputs = getMapFromMaps (conf, "main", "tmpPath");
   char *sid=getStatusId(conf,pid);
   if(sid==NULL){
     errorException (conf, _("The JobID from the request does not match any of the Jobs running on this server"),
-		    "NoSuchJob", pid);
+		    "NoSuchJob", pid,out);
   }else{
     map* statusInfo=createMap("JobID",pid);
@@ -861,5 +861,5 @@
       if(strncasecmp(req,"GetResult",strlen(req))==0){
 	errorException (conf, _("The result for the requested JobID has not yet been generated. "),
-			"ResultNotReady", pid);
+			"ResultNotReady", pid,out);
 	return;
       }
@@ -885,7 +885,7 @@
 	if(result!=NULL){
 	  char *encoding=getEncoding(conf);
-	  fprintf(stdout,"Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",encoding);
-	  fprintf(stdout,"%s",result);
-	  fflush(stdout);
+      FCGX_FPrintF(out,"Content-Type: text/xml; charset=%s\r\nStatus: 200 OK\r\n\r\n",encoding);
+      FCGX_FPrintF(out,"%s",result);
+      FCGX_FFlush(out);
 	  freeMap(&statusInfo);
 	  free(statusInfo);
@@ -893,5 +893,5 @@
 	}else{
 	  errorException (conf, _("The result for the requested JobID has not yet been generated. "),
-			  "ResultNotReady", pid);
+			  "ResultNotReady", pid,out);
 	  freeMap(&statusInfo);
 	  free(statusInfo);
@@ -914,5 +914,5 @@
 	}
     }
-    printStatusInfo(conf,statusInfo,req);
+    printStatusInfo(conf,statusInfo,req,out);
     freeMap(&statusInfo);
     free(statusInfo);
@@ -927,10 +927,10 @@
  * @param pid the service identifier (usid key from the [lenv] section)
  */
-void runDismiss(maps* conf,char* pid){
+void runDismiss(maps* conf,char* pid,FCGX_Stream* out){
   map* r_inputs = getMapFromMaps (conf, "main", "tmpPath");
   char *sid=getStatusId(conf,pid);
   if(sid==NULL){
     errorException (conf, _("The JobID from the request does not match any of the Jobs running on this server"),
-		    "NoSuchJob", pid);
+		    "NoSuchJob", pid,out);
   }else{
     // We should send the Dismiss request to the target host if it differs
@@ -967,5 +967,5 @@
 	  if(unlink(fileName)!=0){
 	    errorException (conf, _("The job cannot be removed, a file cannot be removed"),
-			    "NoApplicableCode", NULL);
+			    "NoApplicableCode", NULL,out);
 	    return;
 	  }
@@ -978,5 +978,5 @@
     map* statusInfo=createMap("JobID",pid);
     addToMap(statusInfo,"Status","Dismissed");
-    printStatusInfo(conf,statusInfo,"Dismiss");
+    printStatusInfo(conf,statusInfo,"Dismiss",out);
     free(statusInfo);
   }
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/server_internal.h
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/server_internal.h	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/server_internal.h	(revision 741)
@@ -31,5 +31,5 @@
 #include <openssl/bio.h>
 #include <openssl/buffer.h>
-
+#include <fcgiapp.h>
 extern   int conf_read(const char*,maps*);
 
@@ -52,6 +52,6 @@
   void parseIdentifier(maps*,char*,char*,char*);
   void dumpMapsValuesToFiles(maps**,maps**);
-  void runDismiss(maps*,char*);
-  void runGetStatus(maps*,char*,char*);
+  void runDismiss(maps*,char*,FCGX_Stream*);
+  void runGetStatus(maps*,char*,char*,FCGX_Stream*);
 
   int isValidLang(maps*,const char*);
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/service_internal.c	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/service_internal.c	(revision 741)
@@ -23,5 +23,4 @@
  */
 
-#include "fcgi_stdio.h"
 #include "service_internal.h"
 #ifdef USE_MS
@@ -293,5 +292,5 @@
 
 #include <windows.h>
-#include <fcgi_stdio.h>
+//#include <fcgi_stdio.h>
 #include <stdio.h>
 #include <conio.h>
@@ -689,5 +688,6 @@
     VSILFILE * fichier=VSIFOpenL(dataSource,"rb");
     VSIStatBuf file_status;
-    VSIStat(dataSource, &file_status);
+    VSIStatL(dataSource,&file_status);
+    //file_status.st_size = 2500;
     if(fichier==NULL){
       char tmp[1024];
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/service_internal.h
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/service_internal.h	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/service_internal.h	(revision 741)
@@ -26,4 +26,7 @@
 #define ZOO_SERVICE_INTERNAL_H 1
 
+
+#include <fcgiapp.h>
+
 #pragma once 
 
@@ -37,5 +40,5 @@
 #define TIME_SIZE 40
 
-#include <libintl.h>
+//#include <libintl.h>
 #include <locale.h>
 /**
@@ -65,6 +68,7 @@
 #define ZOO_LOCK_MAX_RETRY 10
 
-#include <sys/stat.h>
-#include <sys/types.h>
+//#include <sys/stat.h>
+//#include <sys/types.h>
+
 #ifndef WIN32
 #include <sys/ipc.h>
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/sqlapi.c
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/sqlapi.c	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/sqlapi.c	(revision 741)
@@ -29,5 +29,5 @@
 
 #include "sqlapi.h"
-#include <fcgi_stdio.h>
+//#include <fcgi_stdio.h>
 #include <stdlib.h>
 
@@ -183,4 +183,5 @@
     sprintf(sqlQuery,"INSERT INTO %s.files (uuid,filename,nature,name) VALUES ('%s','%s','%s',NULL);",schema->value,uusid->value,filename,type);
   execSql(conf,sqlQuery);
+  free(sqlQuery);
   cleanUpResultSet(conf);
 }
@@ -206,4 +207,5 @@
 	  uusid->value,sid->value,osid->value);
   execSql(conf,sqlQuery);
+  free(sqlQuery);
   cleanUpResultSet(conf);
 }
@@ -229,4 +231,6 @@
   sprintf(sqlQuery,"INSERT INTO %s.responses (content,uuid) VALUES ($$%s$$,$$%s$$);",schema->value,tmps,sid->value);
   execSql(conf,sqlQuery);
+  free(sqlQuery);
+  free(tmps);
   cleanUpResultSet(conf);
 }
@@ -250,4 +254,5 @@
   execSql(conf,sqlQuery);
   cleanUpResultSet(conf);
+  free(sqlQuery);
   return 0;
 }
@@ -280,4 +285,5 @@
   }
   cleanUpResultSet(conf);
+  free(sqlQuery);
   return (char*)tmp1;
 }
@@ -316,4 +322,5 @@
     tmp1=NULL;
   cleanUpResultSet(conf);
+  free(sqlQuery);
   return (char*)tmp1;
 }
@@ -338,4 +345,5 @@
   cleanUpResultSet(conf);
   close_sql(conf);
+  free(sqlQuery);
   end_sql();
 }
@@ -363,4 +371,5 @@
   cleanUpResultSet(conf);
   close_sql(conf);
+  free(sqlQuery);
   end_sql();
 }
@@ -397,4 +406,5 @@
   if(hasRes<0)
     tmp1=NULL;
+  free(sqlQuery);
   return (char*)tmp1;
 }
@@ -429,4 +439,5 @@
   if(hasRes<0)
     addToMap(statusInfo,"Status","Failed");
+  free(sqlQuery);
   return;
 }
@@ -460,4 +471,5 @@
   }
   cleanUpResultSet(conf);
+  free(sqlQuery);
   return res;
 }
Index: branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/ulinet.h
===================================================================
--- branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/ulinet.h	(revision 678)
+++ branches/PublicaMundi_David_integration_01-devel/zoo-project/zoo-kernel/ulinet.h	(revision 741)
@@ -26,5 +26,5 @@
 #define _ULINET_H
 
-#include "fcgi_stdio.h"
+//#include "fcgi_stdio.h"
 #include <stdlib.h>
 #include <fcntl.h>
